// EX1_01.CPP
// A Simple Example of a Program
#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
   bool supMMX = true;		// variable for testing MMX technology
   bool supSSE = true;		// variable for testing SSE tech
   bool supSSE2 = true;		// var for SSE2 tech
// these bools are all BYTE PTRs in Assembly Language.

// addition of two integer arrays with MMX (and SSE2)
   int a1[] = {130, 111, 142, 413, 314, 115, 176, 917};
   int b1[] = {105, 991, 809, 107, 968, 553, 847, 431};
   int c1[8];
   int d1[8] = {1,1,1,1,1,1,1,1};
   int asize = sizeof(a1)/4;	// # of variables in a1 (8)
// these INTs and arrays are all DWORD PTRs in Assembly Language

// input variables, eventually are output as well.
   double toy1;
   float toy2;

// Polar Coordinate Variables
   float toyr, toyt;
   int deg = 180;

// remember F7 to Compile, CTRL-F5 to Execute, 
// CTRL-F10 Debug run to cursor.
   
   _asm {
		mov supMMX, 1
		mov EAX, 1
		cpuid
		test EDX, 0x800000
		jnz sup
		mov supMMX, 0
sup:
		mov supSSE, 1
		mov EAX, 1
		cpuid
		test EDX, 0x2000000
		jnz found
		mov supSSE, 0
found:
		mov supSSE, 1
		mov EAX, 1
		cpuid
		test EDX, 0x4000000
		jnz found2
		mov supSSE2, 0
found2:
   }

   cout << endl << endl << endl << endl;               // Start output on a new line
   cout << "     MMX *--* SSE *--* SSE2" << endl;
   cout << "*------------------------------*" << endl;
   cout << "     Technology Analysis" << endl;
   cout << "*------------------------------*" << endl;
   cout << "  and Experiments by Jeff C" << endl << endl << endl;

   // display results of MMX CPUID test
   if (supMMX)
	   cout << "MMX Extensions" << endl;
   else
		cout << "NO MMX" << endl;

   // display results of SSE CPUID test
   if (supSSE)
	   cout << "SSE Extensions" << endl;
   else
	   cout << "NO SSE" << endl;

   // display results of SSE2 CPUID test
   if (supSSE2)
	   cout << "SSE2 Extensions POWERHOUSE!!!!!" << endl;
   else
	   cout << "NO SSE2" << endl;

   _asm {
		lea esi, dword ptr a1
		lea edi, dword ptr b1
		lea edx, dword ptr c1
		mov ecx, 2
howard_the_duck:
		movdqu xmm0, xmmword ptr [esi]
		movdqu xmm1, xmmword ptr [edi]
		paddq xmm0, xmm1
		movdqu xmmword ptr [edx], xmm0
		add esi, 16
	    add edi, 16
		add edx, 16
		loop howard_the_duck
		emms
// general purpose assembly to the rescue in multiplication.
		lea esi, dword ptr a1
		lea edi, dword ptr b1
		lea ebx, dword ptr d1
		mov ecx, 8
multiply_howard:
		mov eax, [esi]
		mov edx, [edi]
		mul edx
		mov [ebx], eax
		add esi, 4
		add edi, 4
		add ebx, 4
		loop multiply_howard
   }

// display both arrays to be added on screen.
    cout << " MMX addition " << endl << "(loops 4 times, adds two 32-bit values from each array simultaneously)" << endl;
    cout << "   a1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(5) << a1[cnt] << " ";
	cout << endl;

	cout << " + b1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(5) << b1[cnt] << " ";
	cout << endl;

// display destination array
    cout << " = c1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(5) << c1[cnt] << " ";
	cout << endl << endl;

// display both arrays to be multiplied on screen.
	cout << " General Purpose Instruction" << endl << "Multiplication of two arrays example, loops 8 times" << endl;
    cout << "   a1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(6) << a1[cnt] << " ";
	cout << endl;

	cout << " * b1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(6) << b1[cnt] << " ";
	cout << endl;

	cout << " = d1: ";
	for (int cnt = 0; cnt < asize; cnt++)
		cout << setw(6) << d1[cnt] << " ";
	cout << endl;

	// input double and float values.
	cout << "Please enter two floating-point numbers: " << endl;
	cin >> toy1 >> toy2;

	// inline assembly using x87 FPU registers.
	// C++ equiv. toy1 += toy2;
/*	_asm {
		fld toy1	// load to st(0)
		fld toy2	// bump st0 to st1, and load to st(0)
		fadd st, st(1)	// adds st(1) to st(0)
		fstp toy1	// store st(0) to toy1
		emms		// clears x87 MMX registers.
	}
*/
	// output values just input
	cout << endl << "You entered: " << toy1 << " and " << toy2 << endl;
	cout << endl << "Cartesian Coordinates (x,y), to Polar Coordinates (r,@theta)" << endl;
	_asm {
		fld toy1
		fmul toy1
		fld toy2
		fmul toy2
		faddp st(1), st(0)
		fsqrt
		fst toyr
		emms
		fld toy2
		fld toy1
		fpatan
		fimul deg
		fldpi			// st0 = pi, st1 = theta*pi
		fdivp st(1), st(0)
		fst toyt
		emms
	}
	cout << endl << "Radius: " << toyr << " Theta: " << toyt << endl;
   cin >> asize;
   return 0;                   // Exit the program
}
